#include "subdivision.h"

Subdivision::Subdivision(QOpenGLFunctions_4_3_Core *f)
{
    this->f =f;
}

Subdivision::~Subdivision()
{
}

Mesh *Subdivision::subdivide(Mesh *mesh) {
	precomputeTables(mesh);
	runShader(mesh);
	return NULL;
}

void Subdivision::precomputeTables(Mesh *mesh) {
    Mesh::Node root = mesh->getRootNode();

    int firstMeshEntryIndex = -1;
    bool meshExists = root.getFirstMeshIndex(firstMeshEntryIndex);
    if (!meshExists){
        qDebug()<<"No Mesh found. Abort subdiv table precomputation.";
        return;
    }
    qDebug()<<"Mesh found. Index:"<<firstMeshEntryIndex;

    //die drei zeilen machen das bild schwarz. wenn man davor returnt tuts.
    Mesh::MeshEntry firstMeshEntry = mesh->getMeshEntry(firstMeshEntryIndex);
    QVector<unsigned int> ib = firstMeshEntry.getIndexBuffer();
    qDebug()<<"Index Buffer: "<<ib;

    return;
    //todo find adjacent triangles:
/*
    for (int i = 0; i < ib.length(); i+=3){
        //schaue alle dreiecke an

        unsigned int x, y, z;
        x_index = ib[i];
        y_index = ib[i+1];
        z_index = ib[i+2];

        //get vertices x,y,z from vertex buffer

        for (int j = i+3; j < ib.length(); j+= 3){
            //search all following triangles for common edge

            a_index = ib[j];
            b_index = ib[j+1];
            c_index = in[j+2];

            //get vertices for a,b,c from vertex buffer

            //for xy

            //for yz

            //for zx
        }

    }
     *
     * */

}

void Subdivision::runShader(Mesh *mesh) {
}
