#ifndef SUBDIVISION_H
#define SUBDIVISION_H

#include <QtOpenGL>
#include <QOpenGLFunctions_4_3_Core>

#include "mesh.h"

class Subdivision
{
public:
    Subdivision(QOpenGLFunctions_4_3_Core *f);
    ~Subdivision();

    Mesh *subdivide(Mesh *mesh);

private:
    QOpenGLFunctions_4_3_Core *f;

    void precomputeTables(Mesh *mesh);
    void runShader(Mesh *mesh);
};

#endif
